#include <stdio.h>
#include <stdlib.h>

#define NO_IDEA 0xfffd

#define E_AIGU 0xe9
#define E_GRAVE 0xe8
#define Y_DIARESIS NO_IDEA
#define E_HACEK NO_IDEA
#define R_HACEK NO_IDEA
#define I_AIGU NO_IDEA
#define Z_HACEK NO_IDEA
#define O_DIARESIS NO_IDEA
#define O_DOUBLE_AIGU NO_IDEA

// Write the UTF8 encoding of code point cp into buf.

// Remark: This function allocates a buffer of five bytes, which is
// never released. Of course, this should be avoided in general,
// we just do it here to make the exercise easier...

char* utf8 (int cp)
{
	char *buf = malloc(5);

	buf[0] = buf[1] = buf[2] = buf[3] = buf[4] = 0;

	if (cp < 0x80) {
		buf[0] = cp;
	} else {
		// to be completed - just treat the first four cases
		// from the UTF8 encoding table
	}

	return buf;
}

int main ()
{
	printf("Charleville-M%szi%sres\n",
		utf8(E_AIGU), utf8(E_GRAVE));
	printf("L'Ha%s-les-Roses\n",
		utf8(Y_DIARESIS));
	printf("Krom%s%s%s%s\n",
		utf8(E_HACEK),utf8(R_HACEK),utf8(I_AIGU),utf8(Z_HACEK));
	printf("G%sd%sll%s\n",
		utf8(O_DIARESIS),utf8(O_DIARESIS),utf8(O_DOUBLE_AIGU));
}
